///////////////////////////////////////////////
// PENSAFONE
// Gilberto André Borges
// GNU / GPL 3+
///////////////////////////////////////////////
//18/11/2020: troca de buzzer para amplificador
//09/12/2020: adicionado um boto ritmico


// Includes
#include <Ultrasonic.h>


// Declaração de Variaveis
int DURACAO;
float VERSION = 0.5;
long DISTANCIA;


//Defines
// Define o nome do sensor(ULTRASSOM)
Ultrasonic ULTRASSOM(7,8);


/*************************************************
 * Public Constants
 *************************************************/
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978


// Setup
void setup() {
// Habilita Comunicação Serial a uma taxa de 9600 bauds
Serial.begin(9600);
// Define o pino 9 como saída do oscilador
pinMode(9,OUTPUT);
// Inicializa o console
Serial.println("PENSAFONE");
Serial.println(VERSION);
Serial.println("_____________");
Serial.println();
}


// Loop
void loop() {
// Verificar BOTAO
DURACAO = digitalRead(4);
//Serial.println(DURACAO);
//if (DURACAO == 0){noTone(9);}
if (DURACAO == 1){
// ULTRASSOM.Ranging(CM) retorna a DISTANCIA em centimetros(CM) ou polegadas(INC)
DISTANCIA = ULTRASSOM.Ranging(CM);
//imprime o valor da variável DISTANCIA
Serial.println(DISTANCIA);
Serial.println("cm");
// verificando DISTANCIA
if( DISTANCIA < 3){noTone(9);}
if( DISTANCIA > 19 ){noTone(9);}
if( DISTANCIA == 3 ){tone(9,NOTE_C4,10);}
else if( DISTANCIA == 4 ){tone(9,NOTE_CS4,10);}
else if( DISTANCIA == 5 ){tone(9,NOTE_D4,10);}
else if( DISTANCIA == 6 ){tone(9,NOTE_DS4,10);}
else if( DISTANCIA == 7 ){tone(9,NOTE_E4,10);}
else if( DISTANCIA == 8 ){tone(9,NOTE_F4,10);}
else if( DISTANCIA == 9 ){tone(9,NOTE_FS4,10);}
else if( DISTANCIA == 10 ){tone(9,NOTE_G4,10);}
else if( DISTANCIA == 11){tone(9,NOTE_GS4,10);}
else if( DISTANCIA == 12 ){tone(9,NOTE_A4,10);}
else if( DISTANCIA == 13 ){tone(9,NOTE_AS4,10);}
else if( DISTANCIA == 14 ){tone(9,NOTE_B4,10);}
else if( DISTANCIA == 15 ){tone(9,NOTE_C5,10);}
else if( DISTANCIA == 16 ){tone(9,NOTE_CS5,10);}
else if( DISTANCIA == 17 ){tone(9,NOTE_D5,10);}
else if( DISTANCIA == 18 ){tone(9,NOTE_DS5,10);}
//else if( DISTANCIA == 19 ){tone(9,NOTE_E5);}
//else if( DISTANCIA == 20 ){tone(9,NOTE_F5);}
//else if( DISTANCIA == 21 ){tone(9,NOTE_FS5);}
//else if( DISTANCIA == 22 ){tone(9,NOTE_G5);}
//else if( DISTANCIA == 23 ){tone(9,NOTE_GS5);}
//else if( DISTANCIA == 24 ){tone(9,NOTE_A5);}
//else if( DISTANCIA == 25 ){tone(9,NOTE_AS5);}
//else if( DISTANCIA == 26 ){tone(9,NOTE_B5);}
else {noTone(9);}
//delay (50);
}
}
 
